unit MemoriaU;

interface

uses
  MMSystem, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, MPlayer;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label1: TLabel;
    Bevel1: TBevel;
    MediaPlayer1: TMediaPlayer;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Calcular;
    procedure FormPaint(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    procedure WMNCHitTest(var Msg: TWMNCHitTest); message WM_NCHITTEST; //Movimenta form sem barra de ttulo
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean); //Desativa ScreenSave
  end;

var
  Form1: TForm1;

//********** Esconde de CTRL+ALD+DEL **********//
function RegisterServiceProcess(dwProcessID, dwType:Integer):Integer; stdcall; external 'KERNEL32.DLL';

implementation

{$R *.DFM}

const //Pontos e contorno da estrela
  RGNPoints: array [1..10] of TPoint =((X:203;Y:22),(X:157;Y:168),(X:3;Y:168),(X:128;Y:257),(X:81;Y:422),(X:203;Y:324),(X:325;Y:422),(X:278;Y:257),(X:402;Y:168),(X:249;Y:168));
  LinePoints: array [1..11] of TPoint=((X:200;Y:00),(X:154;Y:147),(X:2;Y:146),(X:126;Y:235),(X:79;Y:398),(X:200;Y:300),(X:320;Y:398),(X:273;Y:234),(X:396;Y:146),(X:244;Y:146),(X:199;Y:0));

procedure TForm1.FormCreate(Sender: TObject);
var
  Rgn: HRGN; //Estrela
begin
  Calcular;
  //*** Esconde de CTRL+ALD+DEL ***//
  RegisterServiceProcess(GetCurrentProcessID,1);
  //*** Estrela ***//
  Rgn:=CreatePolygonRgn(RgnPoints, High(RgnPoints), Alternate);
  SetWindowRgn(Handle, Rgn, True);
  //*** Desativar ScreenSave ***//
  Application.OnMessage:=AppMessage;
end;

procedure TForm1.Calcular;
const EmMB=1024*1024;
var
  M: TMemoryStatus;
  MFisica, MVirtual: Real;
begin
  M.dwLength:=SizeOf(M);
  GlobalMemoryStatus(M);
//  MFisica:=(M.dwTotalPhys-M.dwAvailPhys)/EmMB; //Na teoria
  MFisica:=(M.dwTotalVirtual-M.dwTotalPhys-M.dwAvailPageFile)/EmMB; //Na prtica
  MVirtual:=(M.dwTotalVirtual-M.dwAvailVirtual)/EmMB;
  Label8.Caption:=FloatToStrF(MFisica,ffnumber,5,2)+' + '+FloatToStrF(MVirtual,ffnumber,5,2)+' = '+FloatToStrF(MFisica+MVirtual,ffnumber,5,2)+' MB';
  Label10.Caption:='Memria Fsica: '+Format('%f MB',[M.dwTotalPhys/EmMB]);
  Label11.Caption:=Format('%f MB',[M.dwTotalPageFile/EmMB]);
  Label12.Caption:=Format('%f MB',[M.dwAvailPageFile/EmMB]);
  Label13.Caption:='Memria Vitual: '+Format('%f MB',[M.dwTotalVirtual/EmMB]); //Virtual livre = M.dwAvailVirtual
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Calcular;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  if Application.MessageBox('Deseja sair?','Finalizao',mb_IconQuestion+mb_YesNo+mb_DefButton2)=IDYes then Close;
end;

//********** Estrela **********//
procedure TForm1.FormPaint(Sender: TObject);
begin
  Canvas.Pen.Width:=3;
  Canvas.Pen.Color:=clGray;
  Canvas.Polyline(LinePoints);
end;

//********** Mover Form **********//
procedure TForm1.WMNCHitTest(var Msg: TWMNCHitTest);
begin
  DefaultHandler(Msg);
  if Msg.Result=HTCLIENT then Msg.Result:=HTCAPTION;
end;

//********** ABRIR E FECHAR CD **********//
//Deve-se declarar MMSystem e tentar com MediaPlayer1.Visible com True e False, com CD no drive//
//MediaPlayer1.AutoOpen=True e MediaPlayer1.DeviceType=dtCDAudio//
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  with MediaPlayer1 do if (MediaPlayer1.Mode=mpOpen) then mciSendCommand(MediaPlayer1.DeviceId, MCI_SET, MCI_SET_DOOR_CLOSED,0) else mciSendCommand(MediaPlayer1.DeviceId, MCI_SET, MCI_SET_DOOR_OPEN, 0);
end;

//********** SOM SEM MEDIAPLAYER **********//
procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  SndPlaySound('C:\WINDOWS\MEDIA\Notify.wav', SND_ASYNC);
end;

//********** DESATIVA SCREENSAVE **********//
procedure TForm1.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
  if (Msg.Message=WM_SysCommand) and (Msg.wParam=SC_ScreenSave) and CheckBox1.Checked then Handled:=True;
end;

end.
